﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Faktorial
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void BtnRekurze_Click(object sender, RoutedEventArgs e)
        {
            long f;

            int.TryParse(TxtCislo.Text, out int n);

            f = FaktorialRekurze(n);
            TxtFaktorial.Text = f.ToString("N0");

        }
        /// <summary>
        /// Metoda s návratem typu long pro výpočet faktoriálu rekurzí
        /// </summary>
        /// <param name="n">číslo pro které chci vypočítat faktoriál</param>
        /// <returns>faktoriál čísla předaného jako parametr</returns>
        private long FaktorialRekurze(int n) 
        {
            if (n == 0)
            {
                return 1;
            }
            else
            {
                return n * FaktorialRekurze(n - 1);
            }
        }

        private void BtnMazat_Click(object sender, RoutedEventArgs e)
        {
            TxtFaktorial.Clear();
        }

        private void BtnKonec_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void BtnFor_Click(object sender, RoutedEventArgs e)
        {
            long f = 1;

            int.TryParse(TxtCislo.Text, out int n);

            for (int i = 1; i <= n; i++)
            {
                f = f * i; // f *= i;
            }

            TxtFaktorial.Text = f.ToString("N0");

        }

        private void BtnWhile_Click(object sender, RoutedEventArgs e)
        {
            long f = 1;
            int i = 1;

            int.TryParse(TxtCislo.Text, out int n);

            while (i <= n) 
            {
                f *= i;
                i++;
            }

            TxtFaktorial.Text = f.ToString("N0");



        }

        private void BtnDoWhile_Click(object sender, RoutedEventArgs e)
        {
            long f = 1;
            int i = 1;

            int.TryParse(TxtCislo.Text, out int n);

            do
            {
                f = f * i;
                i++;
            } while (i <=n);

            TxtFaktorial.Text = f.ToString("N0");
        }
    }
}
